using UnityEditor;
using UnityEngine;

namespace InnoGames.Modules.DateTimeProvider
{
    [InitializeOnLoad]
    public class CompileTimer
    {
        private const string CompileStartTimePrefName = "CompileStartTime";
        
        private static bool isTrackingTime;
        private static double startTime;

        static CompileTimer()
        {
            EditorApplication.update += Update;
            startTime = PlayerPrefs.GetFloat(CompileStartTimePrefName, 0);
            if (startTime > 0)
            {
                isTrackingTime = true;
            }
        }

        private static void Update()
        {
            if (EditorApplication.isCompiling && !isTrackingTime)
            {
                startTime = EditorApplication.timeSinceStartup;
                PlayerPrefs.SetFloat(CompileStartTimePrefName, (float) startTime);
                isTrackingTime = true;
            }
            else if (!EditorApplication.isCompiling && isTrackingTime)
            {
                var finishTime = EditorApplication.timeSinceStartup;
                isTrackingTime = false;
                var compileTime = finishTime - startTime;
                PlayerPrefs.DeleteKey(CompileStartTimePrefName);
                Debug.Log("Script compilation time: \n" + compileTime.ToString("0.000") + "s");
            }
        }
    }
}

