using System;
using System.Collections.Generic;
using Newtonsoft.Test3Json.Shims;

namespace Newtonsoft.Test3Json.Linq.JsonPath
{
    [Preserve]
    internal class QueryFilter : PathFilter
    {
        public QueryExpression Expression { get; set; }

        public override IEnumerable<JToken> ExecuteFilter(IEnumerable<JToken> current, bool errorWhenNoMatch)
        {
            foreach (JToken t in current)
            {
                foreach (JToken v in t)
                {
                    if (Expression.IsMatch(v))
                    {
                        yield return v;
                    }
                }
            }
        }
    }
}